/* card.c 
 * Petr Blaha 1999  engeneer@h-tech.cz rewrite for support /dev/radio
 */

#include <fcntl.h>
#include <sys/ioctl.h>


#include <linux/videodev.h>

#include "card.h"

struct video_audio va;


static  int dev;
static  int cardFound;



/* Initialises the card (and returns 40 if error) */ 

int CardInit(void)
{
  dev = open ("/dev/radio", O_RDONLY );


 if (dev != -1)
   {
    cardFound = 1;
    return 0;
    }
  else 
      { 
       cardFound = 0; 
       return 40;
       }
 
}

void CardClose(void)
{
 /* close /dev/radio */
  if (cardFound)
    close(dev);
}

void CardOff(void)
{
   /* switch card off */
  if (cardFound)
    {
      va.flags = VIDEO_AUDIO_MUTE;
      va.audio = 0;
      va.volume = 0;
      ioctl (dev, VIDIOCSAUDIO, &va);
    }


}

void setVolume(int v)
{
  if (cardFound)
    {
      if ((v>=0) && (v<16))
        {
          va.flags = VIDEO_AUDIO_VOLUME;
          va.audio = 0;
          va.volume = v * (65535/16);
          ioctl (dev, VIDIOCSAUDIO, &va);
        }
    }
}

/* Determine and return the appropriate frequency multiplier for
   the first tuner on the open video device with handle FD. */
double get_freq_fact (int fd)
{
       struct video_tuner tuner;
       tuner.tuner = 0;
       if (-1 == ioctl (fd, VIDIOCGTUNER, &tuner)
           || (tuner.flags & VIDEO_TUNER_LOW) == 0)
               return .16;
       return 160.;
}


void Tune(double freq)
{
unsigned long xl_freq; 
 if (cardFound)
    {
      struct video_tuner v;
      xl_freq = (unsigned long)((freq*100)*get_freq_fact(dev)+0.5);
      v.tuner = 0;
      ioctl (dev, VIDIOCSFREQ, &xl_freq);
    }

}


